Attribute VB_Name = "Ligne_Pt"

'---------------------------------------------------------------------------
Function DistPointLigne(p As Point3, Line As Line3, t As Double) As Double
Dim diff As Point3
    diff = VecSub(p, Line.origin)
    t = Dot(Line.Direction, diff) / Dot(Line.Direction, Line.Direction)
    diff = VecSub(diff, Line.Direction, t)
    DistPointLigne = Sqr(Dot(diff, diff))
End Function
'---------------------------------------------------------------------------
Function DistPointRayon(p As Point3, ray As Line3, t As Double) As Double
Dim diff As Point3
    diff = VecSub(p, ray.origin)
    t = Dot(ray.Direction, diff)

    If (t <= 0) Then
        t = 0
    Else
        t = t / Dot(ray.Direction, ray.Direction)
        diff = VecSub(diff, ray.Direction, t)
    End If

    DistPointRayon = Sqr(Dot(diff, diff))
End Function
'---------------------------------------------------------------------------
Function DistPointSegment(p As Point3, seg As Line3, t As Double) As Double
Dim diff As Point3
Dim mDotm As Double

    diff = VecSub(p, seg.origin)
    t = Dot(seg.Direction, diff)

    If (t <= 0) Then
        t = 0
    Else
        mDotm = Dot(seg.Direction, seg.Direction)
        If (t >= mDotm) Then
            t = 1
            diff = VecSub(diff, seg.Direction)
        Else
            t = t / mDotm
            diff = VecSub(diff, seg.Direction, t)
        End If
    End If
    
    DistPointSegment = Sqr(Dot(diff, diff))
End Function
'---------------------------------------------------------------------------
